package main

// Code generated by peg bf.peg DO NOT EDIT

import (
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
)

const endSymbol rune = 1114112

/* The rule types inferred from the grammar are below. */
type pegRule uint8

const (
	ruleUnknown pegRule = iota
	ruleprogram
	rulesymbol
	ruleo2
	rulesetZero
	ruleo1
	ruleincptr
	ruledecptr
	ruleincval
	ruledecval
	ruleo0
	ruleputchr
	rulegetchr
	rulestartLoop
	ruleendLoop
	rulesep
	ruleAction0
	rulePegText
	ruleAction1
	ruleAction2
	ruleAction3
	ruleAction4
	ruleAction5
	ruleAction6
	ruleAction7
	ruleAction8
)

var rul3s = [...]string{
	"Unknown",
	"program",
	"symbol",
	"o2",
	"setZero",
	"o1",
	"incptr",
	"decptr",
	"incval",
	"decval",
	"o0",
	"putchr",
	"getchr",
	"startLoop",
	"endLoop",
	"sep",
	"Action0",
	"PegText",
	"Action1",
	"Action2",
	"Action3",
	"Action4",
	"Action5",
	"Action6",
	"Action7",
	"Action8",
}

type token32 struct {
	pegRule
	begin, end uint32
}

func (t *token32) String() string {
	return fmt.Sprintf("\x1B[34m%v\x1B[m %v %v", rul3s[t.pegRule], t.begin, t.end)
}

type node32 struct {
	token32
	up, next *node32
}

func (node *node32) print(w io.Writer, pretty bool, buffer string) {
	var print func(node *node32, depth int)
	print = func(node *node32, depth int) {
		for node != nil {
			for c := 0; c < depth; c++ {
				fmt.Fprintf(w, " ")
			}
			rule := rul3s[node.pegRule]
			quote := strconv.Quote(string(([]rune(buffer)[node.begin:node.end])))
			if !pretty {
				fmt.Fprintf(w, "%v %v\n", rule, quote)
			} else {
				fmt.Fprintf(w, "\x1B[34m%v\x1B[m %v\n", rule, quote)
			}
			if node.up != nil {
				print(node.up, depth+1)
			}
			node = node.next
		}
	}
	print(node, 0)
}

func (node *node32) Print(w io.Writer, buffer string) {
	node.print(w, false, buffer)
}

func (node *node32) PrettyPrint(w io.Writer, buffer string) {
	node.print(w, true, buffer)
}

type tokens32 struct {
	tree []token32
}

func (t *tokens32) Trim(length uint32) {
	t.tree = t.tree[:length]
}

func (t *tokens32) Print() {
	for _, token := range t.tree {
		fmt.Println(token.String())
	}
}

func (t *tokens32) AST() *node32 {
	type element struct {
		node *node32
		down *element
	}
	tokens := t.Tokens()
	var stack *element
	for _, token := range tokens {
		if token.begin == token.end {
			continue
		}
		node := &node32{token32: token}
		for stack != nil && stack.node.begin >= token.begin && stack.node.end <= token.end {
			stack.node.next = node.up
			node.up = stack.node
			stack = stack.down
		}
		stack = &element{node: node, down: stack}
	}
	if stack != nil {
		return stack.node
	}
	return nil
}

func (t *tokens32) PrintSyntaxTree(buffer string) {
	t.AST().Print(os.Stdout, buffer)
}

func (t *tokens32) WriteSyntaxTree(w io.Writer, buffer string) {
	t.AST().Print(w, buffer)
}

func (t *tokens32) PrettyPrintSyntaxTree(buffer string) {
	t.AST().PrettyPrint(os.Stdout, buffer)
}

func (t *tokens32) Add(rule pegRule, begin, end, index uint32) {
	if tree := t.tree; int(index) >= len(tree) {
		expanded := make([]token32, 2*len(tree))
		copy(expanded, tree)
		t.tree = expanded
	}
	t.tree[index] = token32{
		pegRule: rule,
		begin:   begin,
		end:     end,
	}
}

func (t *tokens32) Tokens() []token32 {
	return t.tree
}

type BF2Go struct {
	Prog

	Buffer string
	buffer []rune
	rules  [26]func() bool
	parse  func(rule ...int) error
	reset  func()
	Pretty bool
	tokens32
}

func (p *BF2Go) Parse(rule ...int) error {
	return p.parse(rule...)
}

func (p *BF2Go) Reset() {
	p.reset()
}

type textPosition struct {
	line, symbol int
}

type textPositionMap map[int]textPosition

func translatePositions(buffer []rune, positions []int) textPositionMap {
	length, translations, j, line, symbol := len(positions), make(textPositionMap, len(positions)), 0, 1, 0
	sort.Ints(positions)

search:
	for i, c := range buffer {
		if c == '\n' {
			line, symbol = line+1, 0
		} else {
			symbol++
		}
		if i == positions[j] {
			translations[positions[j]] = textPosition{line, symbol}
			for j++; j < length; j++ {
				if i != positions[j] {
					continue search
				}
			}
			break search
		}
	}

	return translations
}

type parseError struct {
	p   *BF2Go
	max token32
}

func (e *parseError) Error() string {
	tokens, err := []token32{e.max}, "\n"
	positions, p := make([]int, 2*len(tokens)), 0
	for _, token := range tokens {
		positions[p], p = int(token.begin), p+1
		positions[p], p = int(token.end), p+1
	}
	translations := translatePositions(e.p.buffer, positions)
	format := "parse error near %v (line %v symbol %v - line %v symbol %v):\n%v\n"
	if e.p.Pretty {
		format = "parse error near \x1B[34m%v\x1B[m (line %v symbol %v - line %v symbol %v):\n%v\n"
	}
	for _, token := range tokens {
		begin, end := int(token.begin), int(token.end)
		err += fmt.Sprintf(format,
			rul3s[token.pegRule],
			translations[begin].line, translations[begin].symbol,
			translations[end].line, translations[end].symbol,
			strconv.Quote(string(e.p.buffer[begin:end])))
	}

	return err
}

func (p *BF2Go) PrintSyntaxTree() {
	if p.Pretty {
		p.tokens32.PrettyPrintSyntaxTree(p.Buffer)
	} else {
		p.tokens32.PrintSyntaxTree(p.Buffer)
	}
}

func (p *BF2Go) WriteSyntaxTree(w io.Writer) {
	p.tokens32.WriteSyntaxTree(w, p.Buffer)
}

func (p *BF2Go) Execute() {
	buffer, _buffer, text, begin, end := p.Buffer, p.buffer, "", 0, 0
	for _, token := range p.Tokens() {
		switch token.pegRule {

		case rulePegText:
			begin, end = int(token.begin), int(token.end)
			text = string(_buffer[begin:end])

		case ruleAction0:
			p.AddBF(TSetZero, 0)
		case ruleAction1:
			p.AddBF(TIncPtr, end-begin)
		case ruleAction2:
			p.AddBF(TDecPtr, end-begin)
		case ruleAction3:
			p.AddBF(TIncVal, end-begin)
		case ruleAction4:
			p.AddBF(TDecVal, end-begin)
		case ruleAction5:
			p.AddBF(TPutChr, 0)
		case ruleAction6:
			p.AddBF(TGetChr, 0)
		case ruleAction7:
			p.AddBF(TLoopBegin, 0)
		case ruleAction8:
			p.AddBF(TLoopEnd, 0)

		}
	}
	_, _, _, _, _ = buffer, _buffer, text, begin, end
}

func (p *BF2Go) Init() {
	var (
		max                  token32
		position, tokenIndex uint32
		buffer               []rune
	)
	p.reset = func() {
		max = token32{}
		position, tokenIndex = 0, 0

		p.buffer = []rune(p.Buffer)
		if len(p.buffer) == 0 || p.buffer[len(p.buffer)-1] != endSymbol {
			p.buffer = append(p.buffer, endSymbol)
		}
		buffer = p.buffer
	}
	p.reset()

	_rules := p.rules
	tree := tokens32{tree: make([]token32, math.MaxInt16)}
	p.parse = func(rule ...int) error {
		r := 1
		if len(rule) > 0 {
			r = rule[0]
		}
		matches := p.rules[r]()
		p.tokens32 = tree
		if matches {
			p.Trim(tokenIndex)
			return nil
		}
		return &parseError{p, max}
	}

	add := func(rule pegRule, begin uint32) {
		tree.Add(rule, begin, position, tokenIndex)
		tokenIndex++
		if begin != position && position > max.end {
			max = token32{rule, begin, position}
		}
	}

	matchDot := func() bool {
		if buffer[position] != endSymbol {
			position++
			return true
		}
		return false
	}

	/*matchChar := func(c byte) bool {
		if buffer[position] == c {
			position++
			return true
		}
		return false
	}*/

	/*matchRange := func(lower byte, upper byte) bool {
		if c := buffer[position]; c >= lower && c <= upper {
			position++
			return true
		}
		return false
	}*/

	_rules = [...]func() bool{
		nil,
		/* 0 program <- <((symbol / sep)* !.)> */
		func() bool {
			position0, tokenIndex0 := position, tokenIndex
			{
				position1 := position
			l2:
				{
					position3, tokenIndex3 := position, tokenIndex
					{
						position4, tokenIndex4 := position, tokenIndex
						if !_rules[rulesymbol]() {
							goto l5
						}
						goto l4
					l5:
						position, tokenIndex = position4, tokenIndex4
						if !_rules[rulesep]() {
							goto l3
						}
					}
				l4:
					goto l2
				l3:
					position, tokenIndex = position3, tokenIndex3
				}
				{
					position6, tokenIndex6 := position, tokenIndex
					if !matchDot() {
						goto l6
					}
					goto l0
				l6:
					position, tokenIndex = position6, tokenIndex6
				}
				add(ruleprogram, position1)
			}
			return true
		l0:
			position, tokenIndex = position0, tokenIndex0
			return false
		},
		/* 1 symbol <- <(o2 / o1 / o0)> */
		func() bool {
			position7, tokenIndex7 := position, tokenIndex
			{
				position8 := position
				{
					position9, tokenIndex9 := position, tokenIndex
					if !_rules[ruleo2]() {
						goto l10
					}
					goto l9
				l10:
					position, tokenIndex = position9, tokenIndex9
					if !_rules[ruleo1]() {
						goto l11
					}
					goto l9
				l11:
					position, tokenIndex = position9, tokenIndex9
					if !_rules[ruleo0]() {
						goto l7
					}
				}
			l9:
				add(rulesymbol, position8)
			}
			return true
		l7:
			position, tokenIndex = position7, tokenIndex7
			return false
		},
		/* 2 o2 <- <setZero> */
		func() bool {
			position12, tokenIndex12 := position, tokenIndex
			{
				position13 := position
				if !_rules[rulesetZero]() {
					goto l12
				}
				add(ruleo2, position13)
			}
			return true
		l12:
			position, tokenIndex = position12, tokenIndex12
			return false
		},
		/* 3 setZero <- <('[' ('+' / '-')+ ']' Action0)> */
		func() bool {
			position14, tokenIndex14 := position, tokenIndex
			{
				position15 := position
				if buffer[position] != rune('[') {
					goto l14
				}
				position++
				{
					position18, tokenIndex18 := position, tokenIndex
					if buffer[position] != rune('+') {
						goto l19
					}
					position++
					goto l18
				l19:
					position, tokenIndex = position18, tokenIndex18
					if buffer[position] != rune('-') {
						goto l14
					}
					position++
				}
			l18:
			l16:
				{
					position17, tokenIndex17 := position, tokenIndex
					{
						position20, tokenIndex20 := position, tokenIndex
						if buffer[position] != rune('+') {
							goto l21
						}
						position++
						goto l20
					l21:
						position, tokenIndex = position20, tokenIndex20
						if buffer[position] != rune('-') {
							goto l17
						}
						position++
					}
				l20:
					goto l16
				l17:
					position, tokenIndex = position17, tokenIndex17
				}
				if buffer[position] != rune(']') {
					goto l14
				}
				position++
				if !_rules[ruleAction0]() {
					goto l14
				}
				add(rulesetZero, position15)
			}
			return true
		l14:
			position, tokenIndex = position14, tokenIndex14
			return false
		},
		/* 4 o1 <- <(incptr / decptr / incval / decval)> */
		func() bool {
			position22, tokenIndex22 := position, tokenIndex
			{
				position23 := position
				{
					position24, tokenIndex24 := position, tokenIndex
					if !_rules[ruleincptr]() {
						goto l25
					}
					goto l24
				l25:
					position, tokenIndex = position24, tokenIndex24
					if !_rules[ruledecptr]() {
						goto l26
					}
					goto l24
				l26:
					position, tokenIndex = position24, tokenIndex24
					if !_rules[ruleincval]() {
						goto l27
					}
					goto l24
				l27:
					position, tokenIndex = position24, tokenIndex24
					if !_rules[ruledecval]() {
						goto l22
					}
				}
			l24:
				add(ruleo1, position23)
			}
			return true
		l22:
			position, tokenIndex = position22, tokenIndex22
			return false
		},
		/* 5 incptr <- <(<'>'+> Action1)> */
		func() bool {
			position28, tokenIndex28 := position, tokenIndex
			{
				position29 := position
				{
					position30 := position
					if buffer[position] != rune('>') {
						goto l28
					}
					position++
				l31:
					{
						position32, tokenIndex32 := position, tokenIndex
						if buffer[position] != rune('>') {
							goto l32
						}
						position++
						goto l31
					l32:
						position, tokenIndex = position32, tokenIndex32
					}
					add(rulePegText, position30)
				}
				if !_rules[ruleAction1]() {
					goto l28
				}
				add(ruleincptr, position29)
			}
			return true
		l28:
			position, tokenIndex = position28, tokenIndex28
			return false
		},
		/* 6 decptr <- <(<'<'+> Action2)> */
		func() bool {
			position33, tokenIndex33 := position, tokenIndex
			{
				position34 := position
				{
					position35 := position
					if buffer[position] != rune('<') {
						goto l33
					}
					position++
				l36:
					{
						position37, tokenIndex37 := position, tokenIndex
						if buffer[position] != rune('<') {
							goto l37
						}
						position++
						goto l36
					l37:
						position, tokenIndex = position37, tokenIndex37
					}
					add(rulePegText, position35)
				}
				if !_rules[ruleAction2]() {
					goto l33
				}
				add(ruledecptr, position34)
			}
			return true
		l33:
			position, tokenIndex = position33, tokenIndex33
			return false
		},
		/* 7 incval <- <(<'+'+> Action3)> */
		func() bool {
			position38, tokenIndex38 := position, tokenIndex
			{
				position39 := position
				{
					position40 := position
					if buffer[position] != rune('+') {
						goto l38
					}
					position++
				l41:
					{
						position42, tokenIndex42 := position, tokenIndex
						if buffer[position] != rune('+') {
							goto l42
						}
						position++
						goto l41
					l42:
						position, tokenIndex = position42, tokenIndex42
					}
					add(rulePegText, position40)
				}
				if !_rules[ruleAction3]() {
					goto l38
				}
				add(ruleincval, position39)
			}
			return true
		l38:
			position, tokenIndex = position38, tokenIndex38
			return false
		},
		/* 8 decval <- <(<'-'+> Action4)> */
		func() bool {
			position43, tokenIndex43 := position, tokenIndex
			{
				position44 := position
				{
					position45 := position
					if buffer[position] != rune('-') {
						goto l43
					}
					position++
				l46:
					{
						position47, tokenIndex47 := position, tokenIndex
						if buffer[position] != rune('-') {
							goto l47
						}
						position++
						goto l46
					l47:
						position, tokenIndex = position47, tokenIndex47
					}
					add(rulePegText, position45)
				}
				if !_rules[ruleAction4]() {
					goto l43
				}
				add(ruledecval, position44)
			}
			return true
		l43:
			position, tokenIndex = position43, tokenIndex43
			return false
		},
		/* 9 o0 <- <(putchr / getchr / startLoop / endLoop)> */
		func() bool {
			position48, tokenIndex48 := position, tokenIndex
			{
				position49 := position
				{
					position50, tokenIndex50 := position, tokenIndex
					if !_rules[ruleputchr]() {
						goto l51
					}
					goto l50
				l51:
					position, tokenIndex = position50, tokenIndex50
					if !_rules[rulegetchr]() {
						goto l52
					}
					goto l50
				l52:
					position, tokenIndex = position50, tokenIndex50
					if !_rules[rulestartLoop]() {
						goto l53
					}
					goto l50
				l53:
					position, tokenIndex = position50, tokenIndex50
					if !_rules[ruleendLoop]() {
						goto l48
					}
				}
			l50:
				add(ruleo0, position49)
			}
			return true
		l48:
			position, tokenIndex = position48, tokenIndex48
			return false
		},
		/* 10 putchr <- <('.' Action5)> */
		func() bool {
			position54, tokenIndex54 := position, tokenIndex
			{
				position55 := position
				if buffer[position] != rune('.') {
					goto l54
				}
				position++
				if !_rules[ruleAction5]() {
					goto l54
				}
				add(ruleputchr, position55)
			}
			return true
		l54:
			position, tokenIndex = position54, tokenIndex54
			return false
		},
		/* 11 getchr <- <(',' Action6)> */
		func() bool {
			position56, tokenIndex56 := position, tokenIndex
			{
				position57 := position
				if buffer[position] != rune(',') {
					goto l56
				}
				position++
				if !_rules[ruleAction6]() {
					goto l56
				}
				add(rulegetchr, position57)
			}
			return true
		l56:
			position, tokenIndex = position56, tokenIndex56
			return false
		},
		/* 12 startLoop <- <('[' Action7)> */
		func() bool {
			position58, tokenIndex58 := position, tokenIndex
			{
				position59 := position
				if buffer[position] != rune('[') {
					goto l58
				}
				position++
				if !_rules[ruleAction7]() {
					goto l58
				}
				add(rulestartLoop, position59)
			}
			return true
		l58:
			position, tokenIndex = position58, tokenIndex58
			return false
		},
		/* 13 endLoop <- <(']' Action8)> */
		func() bool {
			position60, tokenIndex60 := position, tokenIndex
			{
				position61 := position
				if buffer[position] != rune(']') {
					goto l60
				}
				position++
				if !_rules[ruleAction8]() {
					goto l60
				}
				add(ruleendLoop, position61)
			}
			return true
		l60:
			position, tokenIndex = position60, tokenIndex60
			return false
		},
		/* 14 sep <- <(!('<' / '>' / [+-.] / ',' / '[' / ']') .)+> */
		func() bool {
			position62, tokenIndex62 := position, tokenIndex
			{
				position63 := position
				{
					position66, tokenIndex66 := position, tokenIndex
					{
						position67, tokenIndex67 := position, tokenIndex
						if buffer[position] != rune('<') {
							goto l68
						}
						position++
						goto l67
					l68:
						position, tokenIndex = position67, tokenIndex67
						if buffer[position] != rune('>') {
							goto l69
						}
						position++
						goto l67
					l69:
						position, tokenIndex = position67, tokenIndex67
						if c := buffer[position]; c < rune('+') || c > rune('.') {
							goto l70
						}
						position++
						goto l67
					l70:
						position, tokenIndex = position67, tokenIndex67
						if buffer[position] != rune(',') {
							goto l71
						}
						position++
						goto l67
					l71:
						position, tokenIndex = position67, tokenIndex67
						if buffer[position] != rune('[') {
							goto l72
						}
						position++
						goto l67
					l72:
						position, tokenIndex = position67, tokenIndex67
						if buffer[position] != rune(']') {
							goto l66
						}
						position++
					}
				l67:
					goto l62
				l66:
					position, tokenIndex = position66, tokenIndex66
				}
				if !matchDot() {
					goto l62
				}
			l64:
				{
					position65, tokenIndex65 := position, tokenIndex
					{
						position73, tokenIndex73 := position, tokenIndex
						{
							position74, tokenIndex74 := position, tokenIndex
							if buffer[position] != rune('<') {
								goto l75
							}
							position++
							goto l74
						l75:
							position, tokenIndex = position74, tokenIndex74
							if buffer[position] != rune('>') {
								goto l76
							}
							position++
							goto l74
						l76:
							position, tokenIndex = position74, tokenIndex74
							if c := buffer[position]; c < rune('+') || c > rune('.') {
								goto l77
							}
							position++
							goto l74
						l77:
							position, tokenIndex = position74, tokenIndex74
							if buffer[position] != rune(',') {
								goto l78
							}
							position++
							goto l74
						l78:
							position, tokenIndex = position74, tokenIndex74
							if buffer[position] != rune('[') {
								goto l79
							}
							position++
							goto l74
						l79:
							position, tokenIndex = position74, tokenIndex74
							if buffer[position] != rune(']') {
								goto l73
							}
							position++
						}
					l74:
						goto l65
					l73:
						position, tokenIndex = position73, tokenIndex73
					}
					if !matchDot() {
						goto l65
					}
					goto l64
				l65:
					position, tokenIndex = position65, tokenIndex65
				}
				add(rulesep, position63)
			}
			return true
		l62:
			position, tokenIndex = position62, tokenIndex62
			return false
		},
		/* 16 Action0 <- <{p.AddBF(TSetZero,0)}> */
		func() bool {
			{
				add(ruleAction0, position)
			}
			return true
		},
		nil,
		/* 18 Action1 <- <{ p.AddBF(TIncPtr, end-begin)}> */
		func() bool {
			{
				add(ruleAction1, position)
			}
			return true
		},
		/* 19 Action2 <- <{ p.AddBF(TDecPtr, end-begin)}> */
		func() bool {
			{
				add(ruleAction2, position)
			}
			return true
		},
		/* 20 Action3 <- <{ p.AddBF(TIncVal, end-begin)}> */
		func() bool {
			{
				add(ruleAction3, position)
			}
			return true
		},
		/* 21 Action4 <- <{ p.AddBF(TDecVal, end-begin)}> */
		func() bool {
			{
				add(ruleAction4, position)
			}
			return true
		},
		/* 22 Action5 <- <{ p.AddBF(TPutChr, 0)}> */
		func() bool {
			{
				add(ruleAction5, position)
			}
			return true
		},
		/* 23 Action6 <- <{p.AddBF(TGetChr, 0)}> */
		func() bool {
			{
				add(ruleAction6, position)
			}
			return true
		},
		/* 24 Action7 <- <{ p.AddBF(TLoopBegin, 0)}> */
		func() bool {
			{
				add(ruleAction7, position)
			}
			return true
		},
		/* 25 Action8 <- <{  p.AddBF(TLoopEnd, 0)}> */
		func() bool {
			{
				add(ruleAction8, position)
			}
			return true
		},
	}
	p.rules = _rules
}
